package org.orbroker.callback

trait LogEmbeddedValues {

  private val ReplaceParmHolders = java.util.regex.Pattern.compile("""(\?)(?=(?:[^']|'[^']*')*$)""")

  def embedValues(sql: String, parms: Seq[Any]): String = {
    var returnSql = sql
    for (parm ← parms) {
      val sqlParm = parm match {
        case null ⇒ "NULL"
        case _@(_: CharSequence | _: java.util.Date) ⇒ "'" + parm + "'"
        case _ ⇒ parm.toString
      }
      returnSql = ReplaceParmHolders.matcher(returnSql).replaceFirst(sqlParm)
    }
    returnSql
  }

}