package org.orbroker.callback

/**
 * Callback to serve as proxy for multiple callbacks.
 */
class MultiProxyCallback(delegates: ExecutionCallback*) extends ExecutionCallback {

  def onSQL(id: Symbol, sql: String, parms: Seq[Any], executionTime: Int) {
    delegates.foreach(_.onSQL(id, sql, parms, executionTime))
  }

  def onSQLBatch(id: Symbol, sql: String, parms: Seq[Seq[Any]], executionTime: Int) {
    delegates.foreach(_.onSQLBatch(id, sql, parms, executionTime))
  }

  def onWarning(warning: java.sql.SQLWarning, source: Either[Symbol, java.sql.Connection]) {
    delegates.foreach(_.onWarning(warning, source))
  }
}
